#ifndef VIETER_PACKAGE
#define VIETER_PACKAGE

#include <stdint.h>
#include <stdbool.h>
#include <string.h>
#include <stdlib.h>

#include <archive.h>
#include <archive_entry.h>

typedef struct pkg Pkg;

/*
 * Parse package file into something usable by libvieter.
 * The pointer returned by this function will need to freed at a later point.
 */
Pkg *vieter_package_read_archive(const char *pkg_path);

/*
 * Deallocate a package.
 */
void vieter_package_free(Pkg ** ptp);

/*
 * Create string that will become the package's desc file.
 */
char *vieter_package_to_description(Pkg *pkg);

#endif
